
module LexOrder() where

-- Lexographical order for monomial degrees

import Data.Function

import Monomial

instance Ord Monomial where
	m1 <= m2
		| m1 == m2   = True
		| v1 == v2   = i1 < i2
		| v1 == ""   = True
		| v2 == ""   = False
		| otherwise  = v1 > v2
		-- otherwise  = head delta <= 0
		where
			((v1,i1),(v2,i2)) = head
				$ dropWhile (uncurry (==))
				$ (zip `on` (++ repeat ("", 0))) (unMono m1) (unMono m2)

